<?php
namespace Teknisa\PLA\Modules\Parametros\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;


class PesoProdutoController extends \Teknisa\GER\Controllers\TeknisaCrud {
	protected $parameterBagColumns;
	protected $crudService;
	protected $dataSourceManager;
	protected $environment;
	protected $parameterBag;

	public function __construct($crudService, $parameterBag, $dataSourceManager, $environment, $entityManager){
		$this->crudService 	        = $crudService;
	    $this->parameterBag         = $parameterBag;
		$this->dataSourceManager    = $dataSourceManager;
		$this->environment 			= $environment;
		$this->entityManager        = $entityManager;

		parent::__construct($crudService, $parameterBag);
	}
	
	public function savePeso(DTO\Request\DataSet $request, DTO\Response $response) {
        $rows = $request->getDataSet()->getRows();
        foreach ($rows as $key => &$data) {
         	$cdfilial = $rows[$key]['CDFILIAL'];
            $nrorg = $rows[$key]['NRORG'];
            $cdproduto = $rows[$key]['CDPRODUTO'];
            if(empty($rows[$key]['VRPESOUNIDFI'])){
                $vrpesounidfi = null;
            }else{
                $vrpesounidfi = $rows[$key]['VRPESOUNIDFI'];
            }
            self::updatePeso($cdfilial, $nrorg, $cdproduto, $vrpesounidfi);
        }
            
    }

	public function updatePeso($cdfilial, $nrorg, $cdproduto, $vrpesounidfi) {
		$sql = "UPDATE PRODFILI
                SET
                CDFILIAL = :CDFILIAL,
                VRPESOUNIDFI = :VRPESOUNIDFI
                WHERE
                CDFILIAL = :CDFILIAL AND
                CDPRODUTO = :CDPRODUTO AND
                NRORG = :NRORG
                ";
        
		$params = array(
		    'CDPRODUTO' => $cdproduto,
            'CDFILIAL' => $cdfilial,
            'NRORG' => $nrorg,
            'VRPESOUNIDFI' => $vrpesounidfi
		);

		$query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
	}

}